//+------------------------------------------------------------------+

//| Wick.mq4 |

//| Seavo |

//| http://www.forexfactory.com/member.php?u=17692 |

//+------------------------------------------------------------------+

#property copyright "Seavo"

#property link "http://www.forexfactory.com/member.php?u=17692"

#property indicator_separate_window

#property indicator_buffers 2

#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_width1 8
#property indicator_width2 8
#property indicator_minimum -10
#property indicator_maximum 10

//---- buffers

extern double upperWickValue=2;
extern double lowerWickValue=-2;
extern string buyLine="tradearea1";
extern string sellLine="tradearea2";
extern int band=20;
extern double dev=2;
extern int shift=0;

double ExtMapBuffer1[];
double ExtMapBuffer2[];

int PipFactor = 1;
datetime NewTime=0;

//+------------------------------------------------------------------+

//| Custom indicator initialization function |

//+------------------------------------------------------------------+

int init()
{
   //---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);

   string short_name = "Wick";

   IndicatorShortName(short_name);
   IndicatorDigits(1);
   
   // Cater for fractional pips
   if (Digits == 3 || Digits == 5)
   {
      PipFactor = 10;
   }

   return(1);
}

//+------------------------------------------------------------------+

//| Custor indicator deinitialization function |

//+------------------------------------------------------------------+

int deinit()
{  
   string objName;
   
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      objName=ObjectName(i);
      
      if(StringFind(buyLine,buyLine,0)>=0)
      {
         ObjectDelete(objName);
      }
      if(StringFind(sellLine,sellLine,0)>=0)
      {
         ObjectDelete(objName);
      }
   } 
   
   return(0);
}

//+------------------------------------------------------------------+

//| Custom indicator iteration function |

//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();

   //---- check for possible errors

   if (counted_bars<0) return(-1);

   //---- last counted bar will be recounted

   if (counted_bars>0) counted_bars--;

   int pos=Bars-counted_bars;


   //---- main calculation loop
   double dResult1;
   double dResult2;
   double dFinalResult1;
   double dFinalResult2;
   
   if(NewTime!=Time[0])
   {  
      NewTime=Time[0];

      while(pos>=0)
      {
         if(iOpen(NULL,0,pos)>iClose(NULL,0,pos))
         {
            dResult1=iHigh(NULL,0,pos)-iOpen(NULL,0,pos);
         }
         if(iOpen(NULL,0,pos)<= iClose(NULL,0,pos))
         {
            dResult1=iHigh(NULL,0,pos)-iClose(NULL,0,pos);
         }
         if(iOpen(NULL,0,pos)>iClose(NULL,0,pos))
         {
            dResult2=iLow(NULL,0,pos)-iClose(NULL,0,pos);
         }
         if(iOpen(NULL,0,pos)<=iClose(NULL,0,pos))
         {
            dResult2=iLow(NULL,0,pos)-iOpen(NULL,0,pos);
         }

         dFinalResult1=(dResult1/Point)/PipFactor;
         dFinalResult2=(dResult2/Point)/PipFactor;

         if(dFinalResult1>upperWickValue && High[pos]>iBands(Symbol(),NULL,band,dev,shift,PRICE_CLOSE,MODE_UPPER,pos))
         {
            ExtMapBuffer1[pos]=dFinalResult1;
            deleteObject(buyLine,buyLine);    
            ObjectCreate(buyLine,OBJ_HLINE,0,Time[0],High[pos],0,0);
            ObjectSet(buyLine,OBJPROP_COLOR,Yellow);
         }
         else
         {
            ExtMapBuffer1[pos]=0.5;
         }
      
         if(dFinalResult2<lowerWickValue && Low[pos]<iBands(Symbol(),NULL,band,dev,shift,PRICE_CLOSE,MODE_LOWER,pos))
         {
            ExtMapBuffer2[pos]=dFinalResult2;
            deleteObject(sellLine,sellLine);
            ObjectCreate(sellLine,OBJ_HLINE,0,Time[0],Low[pos],0,0);
            ObjectSet(sellLine,OBJPROP_COLOR,Yellow);
         }
         else
         {
            ExtMapBuffer2[pos]=-0.5;
         }
      
         pos--;
      }
   }
   return(0);
}

bool deleteObject(string objName,string findArea) 
{  
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      objName=ObjectName(i);
      
      if(StringFind(objName,findArea,0)>=0)
      {
         ObjectDelete(objName);
      }
   }   
   return(0);
}
//+------------------------------------------------------------------+